stages:
  - test
  - tasks

.version:
  stage: tasks
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: manual
  variables:
    GIT_STRATEGY: clone
    GIT_DEPTH: '1'
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .npm/
  before_script:
    - apk add git
    - git config --global user.email "chris.case@g33xnexus.com"
    - git config --global user.name "Christopher S. Case"
    - git remote set-url origin https://root:$REPO_TOKEN@$CI_SERVER_HOST/$CI_PROJECT_PATH.git
    - echo "//registry.npmjs.org/:_authToken=${NPM_TOKEN}" > .npmrc
    - echo "unsafe-perm" >> .npmrc
  script:
    - npm ci --cache .npm --prefer-offline --quiet
    - npm version $VERSION
    - npm publish --access public
    - git push --follow-tags -o ci.skip origin HEAD:master
  image: node:14-alpine

lint:
  stage: test
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $CI_DEFAULT_BRANCH'
  variables:
    GIT_DEPTH: '1'
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .npm/
  script:
    - npm ci --cache .npm --prefer-offline --quiet
    - npm run lint
  image: node:14-alpine

test:
  stage: test
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $CI_DEFAULT_BRANCH'
  variables:
    GIT_DEPTH: '1'
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .npm/
  script:
    - npm ci --cache .npm --prefer-offline --quiet
    - npm run test
  image: node:14-alpine

version:major:
  extends: .version
  variables:
    VERSION: 'major'

version:minor:
  extends: .version
  variables:
    VERSION: 'minor'

version:patch:
  extends: .version
  variables:
    VERSION: 'patch'
